#!/usr/bin/perl
# 
# library - time 
# == scripted by Takuya Otani ========
# == copyright (C) SimpleBoxes 2004 ==

{
	my $aVersion_ = 0.03;
}

# бեޥå
#    %yr : ǯ           %Yr : ǯ(2ɽ)
#    %mo : (2)    %MO : (¸ / û̷)     %mO : (¸) %Mo : ()
#    %dy : (2)    %DY : (+st/nd/rd/th)  %Dy : ()
#    %wk : (û̷) %Wk : 
#    %hr : (2ɽ)  %Hr : 12ɽ(0-11)    %hR : 12ɽ(1-12)   %HR : AM/PM ɽ
#    %mi : ʬ(2ɽ)
#    %sc : (2ɽ)
# ʥåѻեޥåȡˡ%wk, %Dy-%MO-%yr %hr:%mi:%sc GMT
sub sbtime_stamp { # եեޥåѴ
	my ($now,$form,$zone,$lang) = @_; # ϥѥ᡼ / ,եޥå,ॾ, /
	my ($out) = ($form);              # ϥѥ᡼
	$zone = &sbtime_zone($zone);
	my ($se,$mi,$ho,$md,$mo,$ye,$wd,$yd,$is) = gmtime($now+$zone);
	if ($out =~ /\%yr/i) { # ǯ
		my $tmp = $ye + 1900;
		if ($out =~ /\%yr/) {
			$out =~ s/\%yr/$tmp/g;
		}
		if ($out =~ /\%Yr/) {
			$tmp = &sbtime_pad0($tmp % 100);
			$out =~ s/\%Yr/$tmp/g;
		}
	}
	if ($out =~ /\%mo/i) { # 
		my $tmp = '';
		if ($out =~ /\%MO/) {
			$tmp = &sbtime_mname($mo,'',$lang);
			$out =~ s/\%MO/$tmp/g;
		}
		if ($out =~ /\%mO/) {
			$tmp = &sbtime_mname($mo,'long',$lang);
			$out =~ s/\%mO/$tmp/g;
		}
		if ($out =~ /\%mo/) {
			$tmp = &sbtime_pad0($mo+1);
			$out =~ s/\%mo/$tmp/g;
		}
		if ($out =~ /\%Mo/) {
			$tmp = $mo + 1;
			$out =~ s/\%Mo/$tmp/g;
		}
	}
	if ($out =~ /\%dy/i) { # 
		my $tmp = '';
		if ($out =~ /\%DY/) {
			$tmp = join('',$md,&sbtime_nsuf($md));
			$out =~ s/\%DY/$tmp/g;
		}
		if ($out =~ /\%dy/) {
			$tmp = &sbtime_pad0($md);
			$out =~ s/\%dy/$tmp/g;
		}
		if ($out =~ /\%Dy/) {
			$tmp = $md;
			$out =~ s/\%Dy/$tmp/g;
		}
	}
	if ($out =~ /\%wk/i) { # 
		my $tmp = '';
		if ($out =~ /\%wk/) {
			$tmp = &sbtime_wname($wd,'',$lang);
			$out =~ s/\%wk/$tmp/g;
		}
		if ($out =~ /\%Wk/) {
			$tmp = &sbtime_wname($wd,'long',$lang);
			$out =~ s/\%Wk/$tmp/g;
		}
	}
	if ($out =~ /\%hr/i) { # 
		my $tmp = '';
		if ($out =~ /\%Hr/) {
			$tmp = ($ho < 12) ? $ho : $ho - 12;
			$tmp = &sbtime_pad0($tmp);
			$out =~ s/\%hr/$tmp/g;
		}
		if ($out =~ /\%hR/) {
			$tmp = ($ho < 12) ? $ho : $ho - 12;
			$tmp = 12 if ($tmp == 0);
			$tmp = &sbtime_pad0($tmp);
			$out =~ s/\%hR/$tmp/g;
		}
		if ($out =~ /\%hr/) {
			$tmp = &sbtime_pad0($ho);
			$out =~ s/\%hr/$tmp/g;
		}
		if ($out =~ /\%HR/) {
			$tmp = ($ho < 12) ? 'AM' : 'PM';
			$out =~ s/\%HR/$tmp/g;
		}
	}
	if ($out =~ /\%mi/) { # ʬ
		$mi = &sbtime_pad0($mi);
		$out =~ s/\%mi/$mi/g;
	}
	if ($out =~ /\%sc/) { # 
		$se = &sbtime_pad0($se);
		$out =~ s/\%sc/$se/g;
	}
	return($out);
}
sub sbtime_zone { # ॾ /* Ūˤ JST , NZST ʤɤɽˤбͽ */
	my ($zone) = @_;      # ϥѥ᡼
	my $aDefZone = 32400; # ʥǥեȥॾ󡦥־ˤ碌ơ32400 ܡ
	if ($zone =~ /^([\+-])(\d\d)(\d\d)/) {
		$zone = ($1 eq '-') ? -3600 * $2 - 60 * $3 : 3600 * $2 + 60 * $3;
	} else {
		$zone = $aDefZone; 
	}
	return($zone);
}
sub sbtime_wname { # Ѵ
	my ($wday,$type,$lang) = @_; # ϥѥ᡼
	return($gMsg{'week'}{$lang . $type}[$wday]);
}
sub sbtime_mname { # Ѵ
	my ($mon,$type,$lang) = @_; # ϥѥ᡼
	return($gMsg{'month'}{$lang . $type}[$mon]);
}
sub sbtime_nsuf { # 
	my ($num) = @_; # ϥѥ᡼
	if    ((($num % 10) == 1)&&($num != 11)) { return('st'); }
	elsif ((($num % 10) == 2)&&($num != 12)) { return('nd'); }
	elsif ((($num % 10) == 3)&&($num != 13)) { return('rd'); }
	else                                     { return('th'); }
}
sub sbtime_pad0 { # ·
	my ($num,$dg) = @_; # ϥѥ᡼ /,(ꤷʤ硢2)/
	$dg = 2 if ($dg eq '');
	$num = "0" x ($dg - length($num)) . $num;
	return($num);
}
sub sbtime_holiday {
	my ($year,$mon,$mday) = @_;        # ϥѥ᡼ / ǯ,, /
	my ($text) = ('');                 # ϥѥ᡼ / ν /
	my $holi = &sblang_holiday($year); # ꥹȤμ
	my %aHoli = %$holi;
	($mon,$mday) = (&sbtime_pad0($mon),&sbtime_pad0($mday));
	$text = $gHoli{"$mon$mday"} if ($aHoli{"$mon$mday"} ne '');
	return($text);
}
sub sbtime_weekday { # programed by OHZAKI Hiroki
	my ($year,$mon,$mday) = @_; # ϥѥ᡼ /ǯ,,/
	my ($wday);                 # ϥѥ᡼ / 06 /
	if ($mon == 1 or $mon == 2) {
		$year--;
		$mon += 12;
	}
	$wday = int($year + int($year / 4) - int($year / 100) + int($year / 400) + int((13 * $mon + 8) / 5) + $mday) % 7;
	return($wday);
}
sub sbtime_lastday { # ǽprogramed by OHZAKI Hiroki
	my ($year,$mon) = @_; # ϥѥ᡼ /ǯ,/
	my ($lday);           # ϥѥ᡼ /ηκǽ/
	$lday = (31,28,31,30,31,30,31,31,30,31,30,31)[$mon - 1] + (($mon == 2) and &sbtime_leapcheck($year));
	return($lday);
}
sub sbtime_leapcheck { # 쥴ꥦαǯå
	return($_[0] % 4 == 0 and ($_[0] % 400 == 0 or $_[0] % 100 != 0));
}
sub sbtime_convtime {
	my ($sc,$mi,$ho,$dy,$mo,$yr,$tz) = @_;
	my $out = $gNowTime;
	use Time::Local;
	$yr = int($yr) - 1900;
	$mo = int($mo) - 1;
	$tz = &sbtime_zone($tz);
	$out = timegm($sc,$mi,$ho,$dy,$mo,$yr) - $tz;
	return($out);
}
1;
