#!/usr/bin/perl
# 
# library - mail 
# == scripted by Takuya Otani ========
# == copyright (C) SimpleBoxes 2004 ==

{
	my $aVersion_ = 0.08;
}

sub sbmail_send { # ᡼
	my ($to,$from,$subj,$body) = @_; # ϥѥ᡼
	my $head = &sbmail_head($to,$from,$subj);
	$body = &sblang_mailtext($body);
	&sbfile_read_datafile('blog');
	eval {
		if ($gData{'blog'}[0]{'stype'} eq 'sendmail') {
			my $sendmail = $gData{'blog'}[0]{'smtp'};
			die() if !(-x $sendmail);
			open(SENDMAIL,"| $sendmail -t -i -f'$from'") or return(0);
			print SENDMAIL $head;
			print SENDMAIL $body;
			close(SENDMAIL);
		} elsif ($gData{'blog'}[0]{'stype'} eq 'smtp') {
			require Net::SMTP;
			my $smtp = Net::SMTP->new($gData{'blog'}[0]{'smtp'},'Hello'=>$gData{'blog'}[0]{'smtp'});
			$smtp->mail($from);
			$smtp->to($to);
			$smtp->data();
			$smtp->datasend($head);
			$smtp->datasend($body);
			$smtp->dataend();
			$smtp->quit;
		}
	};
	return(0) if ($@); # 
	return(1); # 
}
sub sbmail_head { # ᡼إå
	my ($to,$from,$subj) = @_; # ϥѥ᡼
	my ($out) = ();            # ϥѥ᡼
	require 'mimeutil.pl';
	$out .= 'To: ' . &sblang_mailtext($to) . "\n";
	$out .= 'From: ' . &sblang_mailtext($from) . "\n";
	$out .= 'Subject: ' . &sblang_mailtext($subj) . "\n";
	$out .= 'MIME-Version: 1.0' . "\n";
	$out .= 'Content-type: text/plain; charset=' . $gMsg{'parts'}{'mailchar'} . "\n";
	$out .= 'Content-Transfer-Encoding: 7bit' . "\n";
	$out .= "\n"; # إåȥܥǥζڤ
	$out = &mimeutil::mimeencode($out);
	return($out);
}
sub sbmail_receive { # ᡼
	my ($srv,$user,$pass,$param) = @_; # ϥѥ᡼
	my @mail;                          # ϥѥ᡼
	eval {
		require Net::POP3;
		my $pop3 = Net::POP3->new($srv) or die('Failed to connect.');
		my $check_auth = undef;
		if ($param->{'apop'}) {
			$check_auth = $pop3->apop($user,$pass);
		} else {
			$pop3->user($user);
			$check_auth = $pop3->pass($pass);
		}
		die('Failed to authorize.') if ($check_auth == undef);
		my $msglist = $pop3->list();
		foreach my $msgid (keys %$msglist) {
			my ($tmp,$data);
			next if (${$msglist}{$msgid} > $param->{'size'} and $param->{'size'} > -1); # ƥ᡼륵ĶƤ
			$tmp = $pop3->top($msgid); # إå
			$data = join('',@$tmp);
			$data = &sbtxt_linefeed($data);
			$data .= "\n" if ($data !~ /\n$/); # ˲Ԥʤ
			$tmp = &sbmail_extract_head($data,'Subject'); # Subject Ф
			next if ($tmp eq '');
			next if ($param->{'subj'} ne '' and index($tmp,$param->{'subj'}) == -1);
			if ($param->{'from'}) {
				my $frm_flag;
				$tmp = &sbmail_extract_head($data,'From'); # From Ф
				foreach (@{$param->{'from'}}) {
					$frm_flag = 1 if (index($tmp,$_) > -1);
					last if ($frm_flag);
				}
				next if (!$frm_flag);
			}
			$tmp = $pop3->get($msgid); # ᡼
			$data = join('',@$tmp) . "\n.\n";
			$data = &sbtxt_linefeed($data);
			push(@mail,$data); # ǡǼ
			$pop3->delete($msgid) if ($param->{'del'}); # ᡼
		}
		$pop3->quit; # ³λ
	};
	die($@) if ($@); # 
	return(@mail); # ᡼뷲֤
	# [ͻ] ==================================================================
	# ⥸塼Ȥä POP3 饤ȤäƤߤ褦
	# http://x68000.q-e-d.net/~68user/net/module-pop3.html
	# Perlǥ᡼
	# file:///C:/_local/private/site/sblog/_making/_references/mail/receivemail.htm
	# -----------------------------------------------------------------------------
	# ϥѥ᡼
	# $srv   : Хɥ쥹
	# $user  : ̾
	# $pass  : ѥ
	# $param : ¾Υѥ᡼
	# 'apop' : APOP Ԥɤ / 0 : APOP ʤ, 1 : APOP 
	# 'subj' : ᡼ Subject 
	# 'from' : ᡼ From  (Υե)
	# 'size' : ƥ᡼륵 ( -1 ˤȥ¤ʤ)
	# 'del'  : ᡼򥵡Ф뤫ɤ / 0 : Ĥ, 1 : 
	# =============================================================================
}
sub sbmail_text_parse { # ᡼
	my $data = shift;              # ϥѥ᡼
	my ($head,$subj,$body,$multi); # ϥѥ᡼
	if ($data =~ /^(.*?)\n\n(.*?)\n\.\n$/s) {
		$head = $1 . "\n";
		$body = $2;
	}
	if ($head =~ /Content-Type:\s?multipart\/mixed;\n?\s?boundary="(.*?)"/si) {
		$multi = '--' . $1;
	} else {
		$multi = '';
	}
	return($head,$body,$multi);
}
sub sbmail_multipart { # multipart 
	my ($data,$boundary) = @_; # ϥѥ᡼
	my @out;                   # ϥѥ᡼
	my @parts = split($boundary, $data);
	shift @parts; # ǸΥѡȤΤƤ
	require 'mimeutil.pl';
	for (my $i=0;$i<@parts;$i++) {
		if($parts[$i] =~ /(.*?)\n\n(.*)/s){
			my ($head,$body) = ($1,$2);
			$out[$i]->{'head'} = $head;
			$out[$i]->{'type'} = &sbmail_part_type($head);
			$out[$i]->{'code'} = &sbmail_part_encode($head);
			$out[$i]->{'name'} = &sbmail_part_name($head);
			if ($out[$i]->{'code'} =~ /Base64/i) {
				$out[$i]->{'body'} = &mimeutil::bodydecode($body,'b64');
				$out[$i]->{'body'} .= &mimeutil::bdeflush('b64');
			} elsif ($out[$i]->{'code'} =~ /Quoted/i) {
				$out[$i]->{'body'}  = &mimeutil::bodydecode($body,'qp');
				$out[$i]->{'body'} .= &mimeutil::bdeflush('qp');
			} else {
				$out[$i]->{'body'} = $body;
			}
		}
	}
	return(\@out);
}
sub sbmail_extract_head { # إåȴФ
	my ($head,$elem) = @_; # ϥѥ᡼
	my $out;               # ϥѥ᡼
	require 'mimeutil.pl';
	if ($head =~ /$elem: (.*?)\n([\w|-]*?): /s) { # إå¸ߤ
		$out = $1;
	} elsif ($head =~ /$elem: (.*?)\n$/s) { # إåκǸ¸ߤ
		$out = $1;
	}
	$out = &mimeutil::mimedecode($out, 'EUC'); # ɸ
	$out =~ s/\n\s?//g;
	$out =~ s/\s$//;
	return($out);
}
sub sbmail_part_type { # Content-Type Ƚ
	my $head = shift;
	return($1) if ($head =~ /Content-Type: (.*?);/si);
	return();
}
sub sbmail_part_name { # ե̾
	my $head = shift;
	return($1) if ($head =~ /Content-Type:\s?.*?;\n?\s*name="(.*?)"/si);
	return();
}
sub sbmail_part_encode { # 󥳡ɥȽ
	my $head = shift;
	return($1) if ($head =~ /Content-Transfer-Encoding: (.*?)\n/si);
	return();
}
1;
